## ldb 2.2.0

=== debian/changelog ===
ldb (2:2.2.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * ldb_dn: avoid head corruption in ldb_dn_explode (CVE-2020-27840)
    (Closes: #985936)
  * pytests: move Dn.validate test to ldb
  * ldb/attrib_handlers casefold: stay in bounds (CVE-2021-20277)
    (Closes: #985935)
  * ldb: add tests for ldb_wildcard_compare
  * ldb tests: ldb_match tests with extra spaces
  * ldb: Remove tests from ldb_match_test that do not pass

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 26 Mar 2021 19:52:18 +0100

ldb (2:2.2.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Mathieu Parent <sathieu@debian.org>  Wed, 18 Nov 2020 20:33:02 +0100

ldb (2:2.2.0-2) experimental; urgency=medium

  * ldb_lmdb_free_list_test also fails on mips64el

 -- Mathieu Parent <sathieu@debian.org>  Wed, 11 Nov 2020 12:39:31 +0100

ldb (2:2.2.0-1) experimental; urgency=medium

  * New upstream version 2.2.0
    - d/watch: Bump to ldb 2.2.x, for samba 4.13.x
    - Update patches
    - Update symbols
  * Generate python3-ldb.symbols to build on all python3 versions
    (Closes: #972912)
  * Update watch file format version to 4.
  * d/copyright: Fix duplicate-globbing-patterns
  * Move to debhelper-compat 13

 -- Mathieu Parent <sathieu@debian.org>  Tue, 10 Nov 2020 17:35:57 +0100

=== debian/control ===
Source: ldb
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
           Mathieu Parent <sathieu@debian.org>
Build-Depends: dh-exec,
               dh-python,
               docbook-xml,
               docbook-xsl,
               libcmocka-dev (>= 1.1.1~),
               libldap2-dev,
               liblmdb-dev (>= 0.9.16),
               libpopt-dev,
               libtalloc-dev (>= 2.3.1~),
               libtdb-dev (>= 1.4.3~),
               libtevent-dev (>= 0.10.2~),
               pkg-config,
               python3,
               python3-dbg,
               python3-dev,
               python3-talloc-dev (>= 2.3.1~),
               python3-tdb (>= 1.4.3~),
               xsltproc,
               debhelper-compat (= 13)
Rules-Requires-Root: no
Homepage: https://ldb.samba.org/
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/samba-team/ldb
Vcs-Git: https://salsa.debian.org/samba-team/ldb.git

Package: libldb2
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Replaces: libldb0
Breaks: ldb-tools (<<1.1.30~),
        libldb0,
        libldb1 (<< 2:2~),
        libsamdb0 (<< 4.0.0~alpha17~git20110724.dfsg1-1),
        python-samba (<< 2:4.7.0~),
        samba (<<2:4.7.0~),
        samba-dsdb-modules (<< 2:4.7.0~),
        samba-libs (<< 2:4.7.0~),
        samba-testsuite (<< 2:4.7.0~)
Description: LDAP-like embedded database - shared library
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 It provides a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains the shared library file.

Package: ldb-tools
Section: utils
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: LDAP-like embedded database - tools
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains bundled test and utility binaries

Package: libldb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb2 (= ${binary:Version}),
         libtalloc-dev,
         libtevent-dev,
         libtdb-dev,
         pkg-config,
         ${misc:Depends}
Description: LDAP-like embedded database - development files
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains the development files.

Package: python3-ldb
Pre-Depends: ${misc:Pre-Depends}
Section: python
Architecture: any
Depends: libldb2 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python:Provides}
Breaks: ${python:Breaks}
Description: Python 3 bindings for LDB
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 This package contains the Python 3 bindings.

Package: python3-ldb-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libc6-dev,
         libldb-dev,
         pkg-config,
         python3-ldb (= ${binary:Version}),
         ${misc:Depends}
Description: LDB Python 3 bindings - development files
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 It is a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains the development files for the Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CFLAGS += -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

LDFLAGS += -Wl,--as-needed

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" \
		./configure --prefix=/usr --disable-rpath-install \
		--builtin-libraries=ccan,replace,tdb_compat \
		--bundled-libraries=NONE,pytevent \
		--minimum-library-version="$(shell ./debian/autodeps.py --minimum-library-version)" \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-modulesdir=/usr/lib/$(DEB_HOST_MULTIARCH)/ldb/modules

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8854
	rm -f .lock-wscript
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8855
	find . -name __pycache__ -o -name "*.pyc" -exec rm -rf {} \;

override_dh_auto_build:
	$(MAKE) all

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) test
endif

override_dh_install:
	DEB_PY3_INCDIR=$(shell python3-config --includes | sed 's,^-I\([^ ]*\).*,\1,') \
		dh_install

override_dh_auto_install:
	DESTDIR=$(DESTDIR) $(MAKE) install
	rm $(DESTDIR)/usr/lib/python*/dist-packages/_tevent*.so
	rm $(DESTDIR)/usr/lib/python*/dist-packages/tevent.py
	ar cr libldb.a bin/default/common/*.o
	mv libldb.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	DEB_PY3_EXTENSION_SUFFIX=$(shell python3-config --extension-suffix | tr '_' '-') \
	  DEB_PY3_EXTENSION_UPCASE=$(shell python3-config --extension-suffix | sed 's/\.so$$//' | tr 'a-z-' 'A-Z_') \
	  debian/python3-ldb.symbols.in > debian/python3-ldb.symbols
	dh_makeshlibs -Xldb. -ppython3-ldb -- -c4
	rm debian/python3-ldb.symbols
	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/ldb -plibldb2 -- -c4

## ldb 2.2.1

=== debian/changelog ===
ldb (2:2.2.1-1A~5.0.0.202103261103) ucs5-0-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    10_ldb_control_bypass_samaccountname_ldap_check

 -- Univention builddaemon <buildd@univention.de>  Fri, 26 Mar 2021 11:03:53 +0100

ldb (2:2.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Fri, 26 Mar 2021 10:38:16 +0100

ldb (2:2.2.0-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Tue, 20 Oct 2020 14:16:08 +0200

ldb (2:1.5.8-1) unstable; urgency=medium

  * New upstream release

 -- Erik Damrose <damrose@univention.de>  Tue, 30 Jun 2020 16:21:10 +0200

ldb (2:1.5.7-1) unstable; urgency=medium

  * New upstream release

 -- root <root@master10.ar41i1.qa>  Tue, 21 Apr 2020 20:55:41 +0200

ldb (2:1.5.6-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Tue, 21 Apr 2020 13:56:00 +0200

ldb (2:1.5.4-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Thu, 21 Mar 2019 12:06:35 +0100

ldb (2:1.5.3-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Fri, 15 Feb 2019 01:26:38 +0100

ldb (2:1.4.4-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Mon, 11 Feb 2019 19:18:11 +0100

ldb (2:1.4.3-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Wed, 12 Dec 2018 18:36:48 +0100

ldb (2:1.4.2-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Mon, 29 Oct 2018 18:01:40 +0100

ldb (2:1.2.3-1) unstable; urgency=low

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Wed, 03 Jan 2018 10:28:30 +0100

## ldb 2.2.3

=== wscript ===
#!/usr/bin/env python

APPNAME = 'ldb'
# For Samba 4.13.x
VERSION = '2.2.3'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist, samba_utils
from waflib import Errors, Options, Logs, Context
import shutil

samba_dist.DIST_DIRS('''lib/ldb:. lib/replace:lib/replace lib/talloc:lib/talloc
                        lib/tdb:lib/tdb lib/tdb:lib/tdb lib/tevent:lib/tevent
                        third_party/popt:third_party/popt
                        third_party/cmocka:third_party/cmocka
                        buildtools:buildtools third_party/waf:third_party/waf''')

samba_dist.DIST_FILES('''lib/util/binsearch.h:lib/util/binsearch.h
                         lib/util/attr.h:lib/util/attr.h''')

def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('ldb', noextension='ldb')
    opt.RECURSE('lib/tdb')
    opt.RECURSE('lib/tevent')
    opt.RECURSE('lib/replace')
    opt.load('python') # options for disabling pyc or pyo compilation

    opt.add_option('--without-ldb-lmdb',
                   help='disable new LMDB backend for LDB',
                   action='store_true', dest='without_ldb_lmdb', default=False)


def configure(conf):
    conf.RECURSE('lib/tdb')
    conf.RECURSE('lib/tevent')

    if conf.CHECK_FOR_THIRD_PARTY():
        conf.RECURSE('third_party/popt')
        conf.RECURSE('third_party/cmocka')
    else:
        if not conf.CHECK_POPT():
            raise Errors.WafError('popt development packages have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_POPT', 1)

        if not conf.CHECK_CMOCKA():
            raise Errors.WafError('cmocka development package have not been found.\nIf third_party is installed, check that it is in the proper place.')
        else:
            conf.define('USING_SYSTEM_CMOCKA', 1)

    conf.RECURSE('lib/replace')
    conf.find_program('xsltproc', var='XSLTPROC')
    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    # where does the default LIBDIR end up? in conf.env somewhere?
    #
    conf.CONFIG_PATH('LDB_MODULESDIR', conf.SUBST_ENV_VAR('MODULESDIR') + '/ldb')

    conf.env.standalone_ldb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_ldb:
        max_ldb_version = [int(x) for x in VERSION.split(".")]
        max_ldb_version[2] = 999
        max_ldb_version_dots = "%d.%d.%d" % tuple(max_ldb_version)

        if conf.env.disable_python:
            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent',
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)
        else:
            using_system_pyldb_util = True
            dflt_name = 'pyldb-util' + conf.all_envs['default']['PYTHON_SO_ABI_FLAG']
            if not conf.CHECK_BUNDLED_SYSTEM_PKG(dflt_name,
                                                 minversion=VERSION,
                                                 maxversion=max_ldb_version_dots,
                                                 onlyif='talloc tdb tevent',
                                                 implied_deps='replace talloc tdb tevent ldb'):
                using_system_pyldb_util = False

            if using_system_pyldb_util:
                conf.define('USING_SYSTEM_PYLDB_UTIL', 1)

            if conf.CHECK_BUNDLED_SYSTEM_PKG('ldb',
                                             minversion=VERSION,
                                             maxversion=max_ldb_version_dots,
                                             onlyif='talloc tdb tevent %s' % dflt_name,
                                             implied_deps='replace talloc tdb tevent'):
                conf.define('USING_SYSTEM_LDB', 1)

    if not conf.CHECK_CODE('return !(sizeof(size_t) >= 8)',
                           "HAVE_64_BIT_SIZE_T_FOR_LMDB",
                           execute=True,
                           msg='Checking for a 64-bit host to '
                           'support lmdb'):
        Logs.warn("--without-ldb-lmdb implied as this "
                  "host is not 64-bit")

        if not conf.env.standalone_ldb and \
           not Options.options.without_ad_dc and \
           conf.CONFIG_GET('ENABLE_SELFTEST'):
            Logs.warn("NOTE: Some AD DC parts of selftest will fail")

        conf.env.REQUIRE_LMDB = False
    else:
        if conf.env.standalone_ldb:
            if Options.options.without_ldb_lmdb:
                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True
        elif Options.options.without_ad_dc:
            conf.env.REQUIRE_LMDB = False
        else:
            if Options.options.without_ldb_lmdb:
                if not Options.options.without_ad_dc and \
                   conf.CONFIG_GET('ENABLE_SELFTEST'):
                    raise Errors.WafError('--without-ldb-lmdb conflicts '
                                         'with --enable-selftest while '
                                         'building the AD DC')

                conf.env.REQUIRE_LMDB = False
            else:
                conf.env.REQUIRE_LMDB = True


    if conf.CONFIG_SET('USING_SYSTEM_LDB'):
        v = VERSION.split('.')
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MAJOR', int(v[0]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_MINOR', int(v[1]))
        conf.DEFINE('EXPECTED_SYSTEM_LDB_VERSION_RELEASE', int(v[2]))

    if conf.env.standalone_ldb:
        conf.CHECK_XSLTPROC_MANPAGES()

        # we need this for the ldap backend
        if conf.CHECK_FUNCS_IN('ber_flush ldap_open ldap_initialize', 'lber ldap', headers='lber.h ldap.h'):
            conf.env.ENABLE_LDAP_BACKEND = True

        # we don't want any libraries or modules to rely on runtime
        # resolution of symbols
        if not sys.platform.startswith("openbsd"):
            conf.ADD_LDFLAGS('-Wl,-no-undefined', testflags=True)

    # if lmdb support is enabled then we require lmdb
    # is present, build the mdb back end and enable lmdb support in
    # the tools.
    if conf.env.REQUIRE_LMDB and \
       not conf.CONFIG_SET('USING_SYSTEM_LDB'):
        if not conf.CHECK_CFG(package='lmdb',
                              args='"lmdb >= 0.9.16" --cflags --libs',
                              msg='Checking for lmdb >= 0.9.16',
                              mandatory=False):
            if not conf.CHECK_CODE('''
                    #if MDB_VERSION_MAJOR == 0 \
                      && MDB_VERSION_MINOR <= 9 \
                      && MDB_VERSION_PATCH < 16
                    #error LMDB too old
                    #endif
                    ''',
                    'HAVE_GOOD_LMDB_VERSION',
                    headers='lmdb.h',
                    msg='Checking for lmdb >= 0.9.16 via header check'):

                if conf.env.standalone_ldb:
                    raise Errors.WafError('ldb build (unless --without-ldb-lmdb) '
                                         'requires '
                                         'lmdb 0.9.16 or later')
                elif not Options.options.without_ad_dc:
                    raise Errors.WafError('Samba AD DC and --enable-selftest '
                                         'requires '
                                         'lmdb 0.9.16 or later')

        if conf.CHECK_FUNCS_IN('mdb_env_create', 'lmdb', headers='lmdb.h'):
            conf.DEFINE('HAVE_LMDB', '1')
            conf.env.HAVE_LMDB = True


    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/tevent')

    if bld.CHECK_FOR_THIRD_PARTY():
        bld.RECURSE('third_party/popt')
        bld.RECURSE('third_party/cmocka')

    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/tdb')

    if bld.env.standalone_ldb:
        if not 'PACKAGE_VERSION' in bld.env:
            bld.env.PACKAGE_VERSION = VERSION
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True
    # we're not currently linking against the ldap libs, but ldb.pc.in
    # has @LDAP_LIBS@
    bld.env.LDAP_LIBS = ''

    LDB_MAP_SRC = bld.SUBDIR('ldb_map',
                             'ldb_map.c ldb_map_inbound.c ldb_map_outbound.c')

    COMMON_SRC = bld.SUBDIR('common',
                            '''ldb_modules.c ldb_ldif.c ldb_parse.c ldb_msg.c ldb_utf8.c
                            ldb_debug.c ldb_dn.c ldb_match.c ldb_options.c ldb_pack.c
                            ldb_attributes.c attrib_handlers.c ldb_controls.c qsort.c''')

    bld.SAMBA_MODULE('ldb_ldap', 'ldb_ldap/ldb_ldap.c',
                     init_function='ldb_ldap_init',
                     module_init_name='ldb_init_module',
                     deps='talloc lber ldap ldb',
                     enabled=bld.env.ENABLE_LDAP_BACKEND,
                     internal_module=False,
                     subsystem='ldb')

    if bld.PYTHON_BUILD_IS_ENABLED():
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            name = bld.pyembed_libname('pyldb-util')
            bld.SAMBA_LIBRARY(name,
                              deps='replace ldb',
                              source='pyldb_util.c',
                              public_headers=('' if private_library else 'pyldb.h'),
                              public_headers_install=not private_library,
                              vnum=VERSION,
                              private_library=private_library,
                              pc_files='pyldb-util.pc',
                              pyembed=True,
                              enabled=bld.PYTHON_BUILD_IS_ENABLED(),
                              abi_directory='ABI',
                              abi_match='pyldb_*')

            if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
                bld.SAMBA_PYTHON('pyldb', 'pyldb.c',
                                 deps='replace ldb ' + name,
                                 realname='ldb.so',
                                 cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        # Do only install this file as part of the Samba build if we do not
        # use the system libldb!
        if not bld.CONFIG_SET('USING_SYSTEM_PYLDB_UTIL'):
            bld.SAMBA_SCRIPT('_ldb_text.py',
                             pattern='_ldb_text.py',
                             installdir='python')

            bld.INSTALL_FILES('${PYTHONARCHDIR}', '_ldb_text.py')

    if not bld.CONFIG_SET('USING_SYSTEM_LDB'):
        if bld.is_install:
            modules_dir = bld.EXPAND_VARIABLES('${LDB_MODULESDIR}')
        else:
            # when we run from the source directory, we want to use
            # the current modules, not the installed ones
            modules_dir = os.path.join(os.getcwd(), 'bin/modules/ldb')

        abi_match = '!ldb_*module_ops !ldb_*backend_ops ldb_*'

        ldb_headers = ('include/ldb.h include/ldb_errors.h '
                       'include/ldb_module.h include/ldb_handlers.h')

        bld.SAMBA_LIBRARY('ldb',
                          COMMON_SRC + ' ' + LDB_MAP_SRC,
                          deps='tevent LIBLDB_MAIN replace',
                          includes='include',
                          public_headers=('' if private_library else ldb_headers),
                          public_headers_install=not private_library,
                          pc_files='ldb.pc',
                          vnum=VERSION,
                          private_library=private_library,

=== buildtools/wafsamba/wscript ===
#!/usr/bin/env python

# this is a base set of waf rules that everything else pulls in first

import os, sys
from waflib import Configure, Logs, Options, Utils, Context, Errors
import wafsamba
from samba_utils import symlink
from optparse import SUPPRESS_HELP

# this forces configure to be re-run if any of the configure
# sections of the build scripts change. We have to check
# for this in sys.argv as options have not yet been parsed when
# we need to set this. This is off by default until some issues
# are resolved related to WAFCACHE. It will need a lot of testing
# before it is enabled by default.
if '--enable-auto-reconfigure' in sys.argv:
    Configure.autoconfig = 'clobber'

def default_value(option, default=''):
    if option in Options.options.__dict__:
        return Options.options.__dict__[option]
    return default

def options(opt):
    opt.load('compiler_cc')

    opt.load('gnu_dirs')

    gr = opt.option_group('library handling options')

    gr.add_option('--bundled-libraries',
                   help=("comma separated list of bundled libraries. May include !LIBNAME to disable bundling a library. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='BUNDLED_LIBS', default='')

    gr.add_option('--private-libraries',
                   help=("comma separated list of normally public libraries to build instead as private libraries. May include !LIBNAME to disable making a library private. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='PRIVATE_LIBS', default='')

    extension_default = default_value('PRIVATE_EXTENSION_DEFAULT')
    gr.add_option('--private-library-extension',
                   help=("name extension for private libraries [%s]" % extension_default),
                   action="store", dest='PRIVATE_EXTENSION', default=extension_default)

    extension_exception = default_value('PRIVATE_EXTENSION_EXCEPTION')
    gr.add_option('--private-extension-exception',
                   help=("comma separated list of libraries to not apply extension to [%s]" % extension_exception),
                   action="store", dest='PRIVATE_EXTENSION_EXCEPTION', default=extension_exception)

    builtin_default = default_value('BUILTIN_LIBRARIES_DEFAULT')
    gr.add_option('--builtin-libraries',
                   help=("command separated list of libraries to build directly into binaries [%s]" % builtin_default),
                   action="store", dest='BUILTIN_LIBRARIES', default=builtin_default)

    gr.add_option('--minimum-library-version',
                   help=("list of minimum system library versions (LIBNAME1:version,LIBNAME2:version)"),
                   action="store", dest='MINIMUM_LIBRARY_VERSION', default='')

    gr.add_option('--disable-rpath',
                   help=("Disable use of rpath for build binaries"),
                   action="store_true", dest='disable_rpath_build', default=False)
    gr.add_option('--disable-rpath-install',
                   help=("Disable use of rpath for library path in installed files"),
                   action="store_true", dest='disable_rpath_install', default=False)
    gr.add_option('--disable-rpath-private-install',
                   help=("Disable use of rpath for private library path in installed files"),
                   action="store_true", dest='disable_rpath_private_install', default=False)
    gr.add_option('--nonshared-binary',
                   help=("Disable use of shared libs for the listed binaries"),
                   action="store", dest='NONSHARED_BINARIES', default='')
    gr.add_option('--disable-symbol-versions',
                   help=("Disable use of the --version-script linker option"),
                   action="store_true", dest='disable_symbol_versions', default=False)

    opt.add_option('--with-modulesdir',
                   help=("modules directory [PREFIX/modules]"),
                   action="store", dest='MODULESDIR', default='${PREFIX}/modules')

    opt.add_option('--with-privatelibdir',
                   help=("private library directory [PREFIX/lib/%s]" % Context.g_module.APPNAME),
                   action="store", dest='PRIVATELIBDIR', default=None)

    opt.add_option('--with-libiconv',
                   help='additional directory to search for libiconv',
                   action='store', dest='iconv_open', default='/usr/local',
                   match = ['Checking for library iconv', 'Checking for iconv_open', 'Checking for header iconv.h'])
    opt.add_option('--without-gettext',
                   help=("Disable use of gettext"),
                   action="store_true", dest='disable_gettext', default=False)

    gr = opt.option_group('developer options')

    gr.add_option('-C',
                   help='enable configure caching',
                   action='store_true', dest='enable_configure_cache')
    gr.add_option('--enable-auto-reconfigure',
                   help='enable automatic reconfigure on build',
                   action='store_true', dest='enable_auto_reconfigure')
    gr.add_option('--enable-debug',
                   help=("Turn on debugging symbols"),
                   action="store_true", dest='debug', default=False)
    gr.add_option('--enable-developer',
                   help=("Turn on developer warnings and debugging"),
                   action="store_true", dest='developer', default=False)
    gr.add_option('--pidl-developer',
                   help=("annotate PIDL-generated code for developers"),
                   action="store_true", dest='pidl_developer', default=False)
    gr.add_option('--disable-warnings-as-errors',
                   help=("Do not treat all warnings as errors (disable -Werror)"),
                   action="store_true", dest='disable_warnings_as_errors', default=False)
    opt.add_option('--enable-coverage',
                   help=("enable options necessary for code coverage "
                         "reporting on selftest (default=no)"),
                   action="store_true", dest='enable_coverage', default=False)
    gr.add_option('--fatal-errors',
                   help=("Stop compilation on first error (enable -Wfatal-errors)"),
                   action="store_true", dest='fatal_errors', default=False)
    gr.add_option('--enable-gccdeps',
                   help=("Enable use of gcc -MD dependency module"),
                   action="store_true", dest='enable_gccdeps', default=True)
    gr.add_option('--pedantic',
		   help=("Enable even more compiler warnings"),
		   action='store_true', dest='pedantic', default=False)
    gr.add_option('--git-local-changes',
		   help=("mark version with + if local git changes"),
		   action='store_true', dest='GIT_LOCAL_CHANGES', default=False)
    gr.add_option('--address-sanitizer',
                   help=("Enable address sanitizer compile and linker flags"),
                   action="store_true", dest='address_sanitizer', default=False)
    gr.add_option('--undefined-sanitizer',
        help=("Enable undefined behaviour sanitizer compile and linker flags"),
        action="store_true",
        dest='undefined_sanitizer',
        default=False)
    gr.add_option('--enable-libfuzzer',
                  help=("Build fuzzing binaries (use ADDITIONAL_CFLAGS to specify compiler options for libFuzzer or use CC=honggfuzz/hfuzz-cc)"),
                  action="store_true", dest='enable_libfuzzer', default=False)
    gr.add_option('--enable-afl-fuzzer',
                  help=("Build fuzzing binaries AFL-style (typically use with CC=afl-gcc)"),
                  action="store_true", dest='enable_afl_fuzzer', default=False)

    # Fuzz targets may need additional LDFLAGS that we can't use on
    # internal binaries like asn1_compile

    gr.add_option('--fuzz-target-ldflags',
                  help=("Linker flags to be used when building fuzz targets"),
                  action="store", dest='FUZZ_TARGET_LDFLAGS', default='')

    gr.add_option('--abi-check',
		   help=("Check ABI signatures for libraries"),
		   action='store_true', dest='ABI_CHECK', default=False)
    gr.add_option('--abi-check-disable',
		   help=("Disable ABI checking (used with --enable-developer)"),
		   action='store_true', dest='ABI_CHECK_DISABLE', default=False)
    gr.add_option('--abi-update',
		   help=("Update ABI signature files for libraries"),
		   action='store_true', dest='ABI_UPDATE', default=False)

    gr.add_option('--show-deps',
		   help=("Show dependency tree for the given target"),
		   dest='SHOWDEPS', default='')

    gr.add_option('--symbol-check',
                  help=("check symbols in object files against project rules"),
                  action='store_true', dest='SYMBOLCHECK', default=False)

    gr.add_option('--dup-symbol-check',
                  help=("check for duplicate symbols in object files and system libs (must be configured with --enable-developer)"),
                  action='store_true', dest='DUP_SYMBOLCHECK', default=False)

    gr.add_option('--why-needed',
                  help=("TARGET:DEPENDENCY check why TARGET needs DEPENDENCY"),
                  action='store', type='str', dest='WHYNEEDED', default=None)

    gr.add_option('--show-duplicates',
                  help=("Show objects which are included in multiple binaries or libraries"),
                  action='store_true', dest='SHOW_DUPLICATES', default=False)

    gr = opt.add_option_group('cross compilation options')

    gr.add_option('--cross-compile',
		   help=("configure for cross-compilation"),
		   action='store_true', dest='CROSS_COMPILE', default=False)
    gr.add_option('--cross-execute',
		   help=("command prefix to use for cross-execution in configure"),
		   action='store', dest='CROSS_EXECUTE', default='')
    gr.add_option('--cross-answers',
		   help=("answers to cross-compilation configuration (auto modified)"),
		   action='store', dest='CROSS_ANSWERS', default='')
    gr.add_option('--hostcc',
		   help=("set host compiler when cross compiling"),
		   action='store', dest='HOSTCC', default=False)

    # we use SUPPRESS_HELP for these, as they are ignored, and are there only
    # to allow existing RPM spec files to work
    opt.add_option('--build',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_BUILD', default='')
    opt.add_option('--host',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_HOST', default='')
    opt.add_option('--target',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_TARGET', default='')
    opt.add_option('--program-prefix',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_PROGRAM_PREFIX', default='')
    opt.add_option('--disable-dependency-tracking',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_DEPENDENCY_TRACKING', default=False)
    opt.add_option('--disable-silent-rules',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_SILENT_RULES', default=False)

    gr = opt.option_group('dist options')
    gr.add_option('--sign-release',
                   help='sign the release tarball created by waf dist',
                   action='store_true', dest='SIGN_RELEASE')
    gr.add_option('--tag',
                   help='tag release in git at the same time',
                   type='string', action='store', dest='TAG_RELEASE')

    opt.add_option('--disable-python',
                    help='do not generate python modules',
                    action='store_true', dest='disable_python', default=False)


@Utils.run_once
def configure(conf):
    conf.env.hlist = []
    conf.env.srcdir = conf.srcnode.abspath()

    conf.define('SRCDIR', conf.env['srcdir'])

    conf.SETUP_CONFIGURE_CACHE(Options.options.enable_configure_cache)

    # load our local waf extensions
    conf.load('gnu_dirs')
    conf.load('wafsamba')

    conf.CHECK_CC_ENV()

    conf.load('compiler_c')

    conf.CHECK_STANDARD_LIBPATH()

    # we need git for 'waf dist'
    conf.find_program('git', var='GIT')

=== third_party/cmocka/wscript ===
#!/usr/bin/env python

from waflib import Options

def configure(conf):
    conf.CHECK_FUNCS('longjmp siglongjmp')

    if conf.CHECK_CMOCKA():
        conf.define('USING_SYSTEM_CMOCKA', 1)

def build(bld):
    if bld.CONFIG_SET('USING_SYSTEM_CMOCKA'):
        return

    extra_libs=''

    # Link to librt if needed for clock_gettime()
    if bld.CONFIG_SET('HAVE_LIBRT'): extra_libs += ' rt'

    bld.SAMBA_LIBRARY('cmocka',
                      source='cmocka.c',
                      deps=extra_libs,
                      allow_warnings=True,
                      private_library=True)

=== debian/changelog ===
ldb (2:2.2.3-2~deb11u2) bullseye-security; urgency=medium

  * d/control: add myself to Uploaders
  * ldb-memory-bug-15096-CVE-2022-32745-4.13-v3.patch:
    only the lib/ldb/* bits from the larger upstream patchset as
    found at https://bugzilla.samba.org/show_bug.cgi?id=15096 , as
    part of the fix for CVE-2022-32745
  * d/*.symbols*: add new symbols and versions

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 01 Aug 2022 17:18:51 +0300

ldb (2:2.2.3-2~deb11u1) bullseye-security; urgency=high

  * Upload to bullseye-security

 -- Mathieu Parent <sathieu@debian.org>  Thu, 04 Nov 2021 20:08:35 +0100

ldb (2:2.2.3-2) unstable; urgency=high

  * Skip failing tests (on 32-bit architectures)

 -- Mathieu Parent <sathieu@debian.org>  Thu, 04 Nov 2021 23:06:24 +0100

ldb (2:2.2.3-1~deb11u1) bullseye-security; urgency=high

  * Upload to bullseye-security

 -- Mathieu Parent <sathieu@debian.org>  Thu, 04 Nov 2021 20:08:35 +0100

ldb (2:2.2.3-1) unstable; urgency=high

  * New upstream version 2.2.3

 -- Mathieu Parent <sathieu@debian.org>  Thu, 04 Nov 2021 19:28:54 +0100

ldb (2:2.2.2-2~deb11u1) bullseye-security; urgency=high

  * Upload to bullseye-security

 -- Mathieu Parent <sathieu@debian.org>  Mon, 01 Nov 2021 15:43:41 +0100

ldb (2:2.2.2-2) unstable; urgency=high

  * Upload to unstable

 -- Mathieu Parent <sathieu@debian.org>  Mon, 01 Nov 2021 08:58:11 +0100

ldb (2:2.2.2-1) experimental; urgency=medium

  [ Mathieu Parent ]
  * Acknowledge NMU
  * New upstream version 2.2.2, includes:
    - CVE-2020-27840: Heap corruption via crafted DN strings.
    - CVE-2021-20277: Out of bounds read in AD DC LDAP server.

  [ Debian Janitor ]
  * Update standards version to 4.5.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Mathieu Parent <sathieu@debian.org>  Sat, 30 Oct 2021 15:57:53 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
 Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
-           Mathieu Parent <sathieu@debian.org>
+           Mathieu Parent <sathieu@debian.org>,
+           Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: dh-exec,
                dh-python,
                docbook-xml,
@@ -25,7 +26,7 @@
                debhelper-compat (= 13)
 Rules-Requires-Root: no
 Homepage: https://ldb.samba.org/
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/samba-team/ldb
 Vcs-Git: https://salsa.debian.org/samba-team/ldb.git

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress https://download.samba.org/pub/ldb/ ldb-(2\.2\..+).tar.gz

## ldb 2.4.2

=== wscript ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/env python
 
 APPNAME = 'ldb'
-# For Samba 4.13.x
-VERSION = '2.2.3'
+# For Samba 4.15.x
+VERSION = '2.4.2'
 
 import sys, os

=== debian/changelog ===
ldb (2:2.4.2-0ubuntu1) jammy; urgency=medium

  * d/watch: start tracking 2.4.x
  * New upstream release: 2.4.2
  * d/p/Fix-FTBFS-Increase-the-over-estimation-for-sparse-fi.patch:
    removed (applied upstream)
  * d/python3-ldb.symbols.in: update symbols
  * d/libldb2.symbols: update symbols

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 15 Feb 2022 18:29:08 -0300

ldb (2:2.2.3-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 11:31:42 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
 CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress https://download.samba.org/pub/ldb/ ldb-(2\.4\..+).tar.gz

## ldb 2.4.4

=== lib/tdb/Makefile ===
# simple makefile wrapper to run waf

WAF_BIN=`PATH=buildtools/bin:../../buildtools/bin:$$PATH which waf`
WAF_BINARY=$(PYTHON) $(WAF_BIN)
WAF=PYTHONHASHSEED=1 WAF_MAKE=1 $(WAF_BINARY)

all:
	$(WAF) build

install:
	$(WAF) install

uninstall:
	$(WAF) uninstall

test: FORCE
	$(WAF) test $(TEST_OPTIONS)

testenv:
	$(WAF) test --testenv $(TEST_OPTIONS)

quicktest:
	$(WAF) test --quick $(TEST_OPTIONS)

dist:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) dist

distcheck:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) distcheck

clean:
	$(WAF) clean

distclean:
	$(WAF) distclean

reconfigure: configure
	$(WAF) reconfigure

show_waf_options:
	$(WAF) --help

# some compatibility make targets
everything: all

testsuite: all

check: test

torture: all

# this should do an install as well, once install is finished
installcheck: test

etags:
	$(WAF) etags

ctags:
	$(WAF) ctags

pydoctor:
	$(WAF) pydoctor

bin/%:: FORCE
	$(WAF) --targets=`basename $@`
FORCE:

=== debian/changelog ===
ldb (2:2.4.4-0ubuntu0.22.04.2) jammy-security; urgency=medium

  * SECURITY UPDATE: Access controlled AD LDAP attributes can be discovered
    - debian/patches/CVE-2023-0614-*.patch: upstream patches to fix the
      issue.
    - debian/libldb2.symbols: added new symbols.
    - CVE-2023-0614

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 30 Mar 2023 08:16:21 -0400

ldb (2:2.4.4-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * No-change rebuild to solve versioning issue preventing upgrades from
    focal to jammy. (LP: #2009895)

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 10 Mar 2023 06:55:45 -0500

ldb (2:2.4.4-0ubuntu0.1) jammy-security; urgency=medium

  * Updated to 2.4.4 to fix security issue.
    - debian/python3-ldb.symbols.in, debian/libldb2.symbols: added new
      symbols.
    - CVE-2022-32746

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 27 Jul 2022 07:27:00 -0400

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: ldb
 Section: devel
 Priority: optional
-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
 Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
-           Mathieu Parent <sathieu@debian.org>,
-           Michael Tokarev <mjt@tls.msk.ru>
+           Mathieu Parent <sathieu@debian.org>
 Build-Depends: dh-exec,
                dh-python,
                docbook-xml,

## ldb 2.5.1

=== debian/changelog ===
ldb (2:2.5.1-1A~5.0.0.202206171844) ucs5-0-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    10_ldb_control_bypass_samaccountname_ldap_check

 -- Univention builddaemon <buildd@univention.de>  Fri, 17 Jun 2022 18:44:26 +0200

ldb (2:2.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Julia Bremer <bremer@univention.de>  Fri, 17 Jun 2022 16:45:37 +0200

ldb (2:2.5.0-1) unstable; urgency=medium

  * New upstream release

 -- Julia Bremer <bremer@univention.de>  Mon, 25 Apr 2022 13:27:26 +0200

ldb (2:2.2.3-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Sat, 06 Nov 2021 11:49:01 +0100

ldb (2:2.2.2-1) unstable; urgency=medium

  * New upstream release

 -- Arvid Requate <requate@univention.de>  Thu, 04 Nov 2021 08:59:18 +0100

## ldb 2.5.2

=== debian/changelog ===
ldb (2:2.5.2-1A~5.1.0.202303161314) ucs5-1-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    10_ldb_control_bypass_samaccountname_ldap_check
    20_symbols

 -- Univention builddaemon <buildd@univention.de>  Thu, 16 Mar 2023 13:14:37 +0100

ldb (2:2.5.2-1) unstable; urgency=medium

  * New source package including upstream security patches for Bug #54994

 -- Arvid Requate <requate@univention.de>  Tue, 19 Jul 2022 17:09:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: ldb
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
+Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
 Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
            Mathieu Parent <sathieu@debian.org>
-Build-Depends: dh-exec,
+Build-Depends: debhelper (>= 11),
+               dh-exec,
                dh-python,
                docbook-xml,
                docbook-xsl,
@@ -22,11 +22,10 @@
                python3-dev,
                python3-talloc-dev (>= 2.3.1~),
                python3-tdb (>= 1.4.3~),
-               xsltproc,
-               debhelper-compat (= 13)
+               xsltproc
+Homepage: https://ldb.samba.org/
 Rules-Requires-Root: no
-Homepage: https://ldb.samba.org/
-Standards-Version: 4.5.1
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/samba-team/ldb
 Vcs-Git: https://salsa.debian.org/samba-team/ldb.git
 
@@ -37,7 +36,8 @@
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Replaces: libldb0
+Replaces: libldb0,
+        libldb1
 Breaks: ldb-tools (<<1.1.30~),
         libldb0,
         libldb1 (<< 2:2~),
@@ -56,6 +56,14 @@
  database.
  .
  This package contains the shared library file.
+
+Package: libldb1
+Depends: libldb2, ${misc:Depends}
+Architecture: all
+Priority: optional
+Section: oldlibs
+Description: transitional package
+ This is a transitional package. It can safely be removed.
 
 Package: ldb-tools
 Section: utils
@@ -103,10 +111,10 @@
          ${shlibs:Depends}
 Provides: ${python:Provides}
 Breaks: ${python:Breaks}
-Description: Python 3 bindings for LDB
+Description: Python3 bindings for LDB
  ldb is a LDAP-like embedded database built on top of TDB.
  .
- This package contains the Python 3 bindings.
+ This package contains the Python bindings.
 
 Package: python3-ldb-dev
 Section: libdevel
@@ -117,7 +125,7 @@
          pkg-config,
          python3-ldb (= ${binary:Version}),
          ${misc:Depends}
-Description: LDB Python 3 bindings - development files
+Description: LDB Python3 bindings - development files
  ldb is a LDAP-like embedded database built on top of TDB.
  .
  It is a fast database with an LDAP-like API designed
@@ -125,4 +133,4 @@
  intermediate solution between key-value pair databases and a real LDAP
  database.
  .
- This package contains the development files for the Python 3 bindings.
+ This package contains the development files for the Python3 bindings.

## ldb 2.5.3

=== debian/changelog ===
ldb (2:2.5.3-1A~5.0.0.202303221553) ucs5-0-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    10_ldb_control_bypass_samaccountname_ldap_check

 -- Univention builddaemon <buildd@univention.de>  Wed, 22 Mar 2023 15:53:41 +0100

ldb (2:2.5.3-1) unstable; urgency=medium

  * New source package including upstream security patches for Bug #55892

 -- Arvid Requate <requate@univention.de>  Wed, 22 Mar 2023 14:40:33 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
 CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
@@ -19,7 +20,7 @@
 
 DESTDIR=$(CURDIR)/debian/tmp
 
-include /usr/share/dpkg/architecture.mk
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
 	dh $@ --with python3
@@ -68,9 +69,5 @@
 	dh_missing --fail-missing
 
 override_dh_makeshlibs:
-	DEB_PY3_EXTENSION_SUFFIX=$(shell python3-config --extension-suffix | tr '_' '-') \
-	  DEB_PY3_EXTENSION_UPCASE=$(shell python3-config --extension-suffix | sed 's/\.so$$//' | tr 'a-z-' 'A-Z_') \
-	  debian/python3-ldb.symbols.in > debian/python3-ldb.symbols
-	dh_makeshlibs -Xldb. -ppython3-ldb -- -c4
-	rm debian/python3-ldb.symbols
+	dh_makeshlibs -Xldb.so -ppython3-ldb -- -c4
 	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/ldb -plibldb2 -- -c4
